; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 656
WINDOWHEIGHT = 518
object struct
 fx	dd ?;int
 fy	dd ?;int
 x	dd ?;int
 y	dd ?;int 
 spin	dd ?;float -  .      
object ends

BITMAPFILEHEADER STRUCT
  bfType        dw ?
  bfSize        dd ?
  bfReserved1   dw ?
  bfReserved2   dw ?
  bfOffBits     dd ?
BITMAPFILEHEADER ENDS

BITMAPINFOHEADER STRUCT
  biSize          dd ?
  biWidth         dd ?
  biHeight        dd ?
  biPlanes        dw ?
  biBitCount      dw ?
  biCompression   dd ?
  biSizeImage     dd ?
  biXPelsPerMeter dd ?
  biYPelsPerMeter dd ?
  biClrUsed       dd ?
  biClrImportant  dd ?
BITMAPINFOHEADER ENDS
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword
local	FSize:dword
local	szReadWrite:QWORD	;number of bytes actually read or write
local	hFile:qword
local	texture:dword
local	loop1:dword
local	loop2:dword
local	buff[10h]:dword

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
	cmp	edx,WM_TIMER
	je	wmTIMER
        cmp	edx,WM_DESTROY
	je      wmDESTROY
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN          
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY:invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
        invoke	KillTimer,hWin,10
	mov	ecx,base
	invoke	glDeleteLists,,256; Delete all 256 Display Lists
	invoke	RtlExitUserProcess,NULL
;------------------------------
wmTIMER:movss	xmm0,const0_5
	addss	xmm0,player.spin
	comiss	xmm0,const360
	jb	@f
	subss	xmm0,const360
@@:	movss	player.spin,xmm0
	invoke	InvalidateRect,,0,FALSE
	jmp	wmBYE
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	cmp	al,VK_A
	jne	@f
	xor	anti,1
	jmp	@0
@@:	cmp	al,VK_SPACE
	jne	@f
	invoke	ResetObjects
	test	Status,00000010y;is Complete=0?
	jnz	@9
	xor	eax,eax
	mov	edi,offset vline
	mov	ecx,220/4
	rep	stosd
	and	Status,11111110y;set gameover=FALSE
	mov	level,1
	mov	stage,1
	mov	lives,5
	jmp	@0
;-------------------------------
@9:	and	Status,11111101y; set Complete=0
	xor	eax,eax
	mov	edi,offset vline
	mov	ecx,220/4
	rep	stosd
	cmp	stage,3
	je	@16
	inc	stage; Increase The Stage
	jmp	@0;if (stage>3)	// Is The Stage Higher Than 3?
@16:	mov	stage,1; If So, Set The Stage To One
	cmp	level,3
	je	@0;if (level>3)	// Is The Level Greater Than 3?
	inc	level; Increase The Level
	jmp	@0
@@:	cmp	al,VK_RIGHT
	jne	@f
	cmp	player.x,10
	jae	wmBYE
	imul	eax,player.x,11
	inc	player.x
	jmp	@6
@@:	cmp	al,VK_LEFT
	jne	@f
	cmp	player.x,0
	jle	wmBYE
	dec	player.x
	imul	eax,player.x,11
@6:	add	eax,player.y
	or	hline[rax],1
	imul	eax,player.x,60
	mov	player.fx,eax
	jmp	@0
@@:	cmp	al,VK_DOWN
	jne	@f
	cmp	player.y,10
	jae	wmBYE
	mov	edx,player.y
	inc	player.y
	jmp	@7
@@:	cmp	al,VK_UP
	jne	wmBYE
	cmp	player.y,0
	jle	wmBYE
	dec	player.y
	mov	edx,player.y
@7:	imul	eax,player.x,10
	or	vline[rax+rdx],1
	imul	eax,player.y,40
	mov	player.fy,eax

@0:	invoke	InvalidateRect,hWin,0,FALSE
	xor	eax,eax
        jmp	wmBYE
;-----------------------------------------	
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	invoke	SetTimer,hWin,10,25,0;  #10  25mSec
;-------------------------------------------------------
	invoke	ResetObjects
;-----------------------------------------------------------
	mov	edx,offset Texture1_Id
	invoke	glGenTextures,10; Create the Texture
	mov	edi,9
@@:	mov	qword ptr [rsp+20h],OPEN_EXISTING
	mov	qword ptr [rsp+28h],FILE_FLAG_SEQUENTIAL_SCAN
	mov	[rsp+30h],rbx
	mov	ecx,FileName0[rdi*4]
	invoke	CreateFile,,GENERIC_READ,0,0
        mov	hFile,rax
        invoke	GetFileSize,eax,0
        mov	FSize,eax
	inc	eax				; Append a 0 char
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,eax
	mov	texture,eax
        mov	esi,eax
	lea	r9d,szReadWrite
        invoke	ReadFile,hFile,eax,FSize,,rbx
        invoke	CloseHandle,hFile
	mov	eax,[rsi + BITMAPINFOHEADER.biWidth + sizeof BITMAPFILEHEADER]
        mov	w,eax;256
        movzx	eax, word ptr [rsi + BITMAPINFOHEADER.biHeight + sizeof BITMAPFILEHEADER]
        mov	h,eax
        add	esi,[rsi + BITMAPFILEHEADER.bfOffBits]
	mov	edx,Texture1_Id[rdi*4]
        invoke	glBindTexture,GL_TEXTURE_2D
	mov	r9d,w
        mov	eax,h
	mov	[rsp+20h],rax
	mov	[rsp+28h],rbx
	mov	qword ptr [rsp+30h],GL_BGR_EXT
	mov	qword ptr [rsp+38h],GL_UNSIGNED_BYTE
	mov	[rsp+40h],rsi
        invoke	glTexImage2D,GL_TEXTURE_2D,0,3
        invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR
        invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
	mov	ecx,texture
	invoke	GlobalFree
	dec	edi
	jns	@b

	invoke	BuildFont
	invoke	glShadeModel,GL_SMOOTH; Enable Smooth Shading
	movss	xmm3,const0_5
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor;(0, 0, 0, 0.5; Black Background
	movsd	xmm0,constd1
	invoke	glClearDepth
	invoke	glHint,GL_LINE_SMOOTH_HINT, GL_NICEST
	invoke	glEnable,GL_BLEND; Enable Blending
	invoke	glBlendFunc,GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA; Type of Blending to Use

        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity
	xorps	xmm3,xmm3
	cvtsi2sd xmm2,h
	cvtsi2sd xmm1,w
	xorps	xmm0,xmm0
        invoke	glOrtho,,,,,constd_1,constd1
	invoke	glMatrixMode,GL_MODELVIEW
	invoke	glLoadIdentity
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke  BeginPaint
; --------------- Display the scene
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
	mov	edx,Texture1_Id[0*4]
	invoke	glBindTexture,GL_TEXTURE_2D; Select Our Font Texture
	movss	xmm2,const1
	movss	xmm1,const0_5
	movss	xmm0,xmm2
	invoke	glColor3f;1,0.5,1 set Color to Purple
	mov	r9d,offset Grid_Crazy
	movss	xmm1,const24
	movss	xmm0,const207
	invoke	glPrint,,,0; Write GRID CRAZY on the screen
	xorps	xmm2,xmm2
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glColor3f;1,1,0	set Color to Yellow

	mov	r9d,offset aLives
	mov	eax,lives
	mov	[rsp+20h],rax
	movss	xmm1,const2
	movss	xmm0,const20
	invoke	glPrint,,,1; Write Actual Level Stats

	mov	r9d,offset aLevel
	mov	eax,level
	mov	[rsp+20h],rax
	movss	xmm1,const20
	movss	xmm0,xmm1
	invoke	glPrint,,,1; Write Actual Level Stats

	mov	r9d,offset aStage
	mov	eax,stage
	mov	[rsp+20h],rax
	movss	xmm1,const38
	movss	xmm0,const20
	invoke	glPrint,,,1
	invoke	rand
	movzx	edi,al
	invoke	rand
	movzx	esi,al
	invoke	rand
	movzx	r8d,al
	invoke	glColor3ub,esi,edi;		Pick a Random Color
	test	Status,00000001y; is the GameOver=0 ?
	jz	@f
	mov	r9d,offset aGame
	movss	xmm1,const20
	movss	xmm0,const472
	invoke	glPrint,,,1;	Write GAME OVER to the screen
	jmp	@8
@@:	test	Status,00000100y;is	SndComplete,0 ?
	jz	@f
	and	Status,11111011y;set	SndComplete=0
@@:	test	Status,00000010y;is	Complete=0 ?
	jz	@f
	mov	r9d,offset aYou_are_win
	movss	xmm1,const20
	movss	xmm0,const448;72
	invoke	glPrint,,,1;	Write GAME OVER to the screen
@8:	mov	r9d,offset aPress
	movss	xmm1,const40
	movss	xmm0,const456
	invoke	glPrint,,,1;	Write PRESS SPACE to the screen

@@:	mov	edi,lives
	cmp	edi,1	;	for (loop1=0; loop1<lives-1; loop1++)		 Loop Through Lives Minus current Life
	jle	@18	
@1:	invoke	glLoadIdentity; Reset the View
	xorps	xmm2,xmm2
	movss	xmm1,const40
	cvtsi2ss xmm0,edi
	mulss	xmm0,xmm1
	addss	xmm0,const490
	invoke	glTranslatef;490+(loop1*40), 40, 0	move to the Right of Our Title Text
	movss	xmm3,const1
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	subss	xmm0,player.spin
	invoke	glRotatef;-player.spin,0,0,1		Rotate Counter Clockwise
	xorps	xmm2,xmm2
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glColor3f;0,1,0		 set Player Color to Light Green

	invoke	glBegin,GL_LINES;		 Start Drawing Our Player Using lines
	xorps	xmm1,xmm1
	subss	xmm1,const5
	movss	xmm0,xmm1
	invoke	glVertex2f;-5,-5		 Top Left of Player
	movss	xmm1,const5
	movss	xmm0,xmm1
	invoke	glVertex2f;( 5, 5); Bottom Right of Player
	xorps	xmm1,xmm1
	movss	xmm0,const5
	subss	xmm1,xmm0
	invoke	glVertex2f;5,-5			 Top Right of Player
	movss	xmm1,const5
	xorps	xmm0,xmm0
	subss	xmm0,xmm1
	invoke	glVertex2f;-5, 5		 Bottom Left of Player
	invoke	glEnd;			 Done Drawing the Player

	movss	xmm3,const1
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	subss	xmm0,const0_5
	mulss	xmm0,player.spin
	invoke	glRotatef;-player.spin*0.5,0,0,1		Rotate Counter Clockwise
	xorps	xmm2,xmm2
	movss	xmm1,const0_75
	xorps	xmm0,xmm0
	invoke	glColor3f;0,0.75,0			 set Player Color to Dark Green

	invoke	glBegin,GL_LINES;		 Start Drawing Our Player Using lines
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	subss	xmm0,const7
	invoke	glVertex2f;-7, 0		 Left Center of Player
	xorps	xmm1,xmm1
	movss	xmm0,const7
	invoke	glVertex2f;7, 0			 Right Center of Player
	xorps	xmm1,xmm1
	subss	xmm1,const7
	xorps	xmm0,xmm0
	invoke	glVertex2f; 0,-7		 Top Center of Player
	movss	xmm1,const7
	xorps	xmm0,xmm0                         
	invoke	glVertex2f;0, 7			 Bottom Center of Player
	invoke	glEnd;			 Done Drawing the Player
	dec	edi;loop1<lives-1
	jnz	@1
;------------------------------------------------------------------------------?
@18:	mov	filled,TRUE;		 set Filled to True Before Testing
	movss	xmm0,const2
	invoke	glLineWidth;		 set Line Width for Cells to 2.0f
	invoke	glDisable,GL_LINE_SMOOTH; Disable Antialiasing
	invoke	glLoadIdentity;			 Reset the current Modelview Matrix

	mov	esi,10;	 Loop From Left to Right
@2:	mov	edi,10;	 Loop From Top to Bottom
@3:	movss	xmm2,const1
	movss	xmm1,const0_5
	xorps	xmm0,xmm0
	invoke	glColor3f;0,0.5,1	 set Line Color to Blue

	imul	eax,esi,11
	cmp	hline[rax+rdi],0; Has the horizontal Line Been Traced
	jz	@f
	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glColor3f;1,1,1		 if so, set Line Color to White

@@:	cmp	esi,10;		 Dont draw to Far Right
	jnb	@4
	imul	eax,esi,11
	cmp	hline[rax+rdi],0;		 if a horizontal Line Isn't Filled
	jnz	@f
	and	filled,FALSE;			 filled becomes False

@@:	invoke	glBegin,GL_LINES;	 Start Drawing horizontal Cell Borders
	imul	eax,edi,40
	add	eax,70
	cvtsi2ss xmm1,eax;70+loop2*40
	imul	eax,esi,60
	add	eax,20
	cvtsi2ss xmm0,eax;20+loop1*60
	invoke	glVertex2f;(20+(loop1*60),70+(loop2*40));// Left Side of horizontal Line
	imul	eax,edi,40
	add	eax,70
	cvtsi2ss xmm1,eax;70+loop2*40
	imul	eax,esi,60
	add	eax,80
	cvtsi2ss xmm0,eax
	invoke	glVertex2f;80+(loop1*60),70+(loop2*40));// Right Side of horizontal Line
	invoke	glEnd; Done Drawing horizontal Cell Borders

@4:	movss	xmm2,const1
	movss	xmm1,const0_5
	xorps	xmm0,xmm0
	invoke	glColor3f;0,0.5,1;	 set Line Color to Blue
	imul	eax,esi,10
	cmp	vline[rax+rdi],0; Has the horizontal Line Been Traced
	jz	@f
	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glColor3f;1,1,1		 if so, set Line Color to White

@@:	cmp	edi,10;			 Dont draw to Far Down
	jnb	@5
        imul	eax, esi,10
	cmp	vline[rax+rdi],0; if a verticle Line Isn't Filled
	jnz	@f
	and	filled,FALSE;		 filled becomes False

@@:	invoke	glBegin,GL_LINES;	 Start Drawing verticle Cell Borders
	imul	eax,edi,40
	add	eax,70
	cvtsi2ss xmm1,eax;70+loop2*40
	imul	eax,esi,60
	add	eax,20
	cvtsi2ss xmm0,eax
	invoke	glVertex2f;(20+(loop1*60),70+(loop2*40));// Left Side of horizontal Line
	imul	eax,edi,40
	add	eax,110
	cvtsi2ss xmm1,eax;70+loop2*40
	imul	eax,esi,60
	add	eax,20
	cvtsi2ss xmm0,eax;
	invoke	glVertex2f;(20+(loop1*60),110+(loop2*40)) Right Side of horizontal Line
	invoke	glEnd;			 Done Drawing verticle Cell Borders

@5:	invoke	glEnable,GL_TEXTURE_2D;	 Enable Texture Mapping
	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glColor3f;1,1,1		 Bright White Color

	mov	eax,level; Loop to draw enemies
	lea	eax,[rax*2+rax-3]
	mov	ecx,stage
	lea	eax,[rax+rcx]
       	mov	edx,Texture1_Id[rax*4]
	invoke	glBindTexture,GL_TEXTURE_2D;;		// Select the Tile Image
	cmp	esi,10
	jnb	@f
	cmp	edi,10;					// if in Bounds, Fill in Traced Boxes
	jnb	@f
; are all Sides of the Box Traced?
	imul	eax, esi,11
	cmp	hline[rax+rdi],0
	jz	@f
	cmp	hline[rax+rdi+1],0
	jz	@f
	sub	eax, esi
	cmp	vline[rax+rdi],0
	jz	@f
	cmp	vline[rax+rdi+10],0
	jz	@f
	invoke	glBegin,GL_QUADS; draw a Textured Quad

	movss	xmm1,const1
	cvtsi2ss xmm0,edi
	mulss	xmm0,const0_1
	subss	xmm1,xmm0

	cvtsi2ss xmm0,esi
	mulss	xmm0,const0_1
	addss	xmm0,const0_1;(loop1/10)+0.1
	invoke	glTexCoord2f;(loop1/10)+0.1,1-(loop2/10));

	imul	eax,edi,40
	add	eax,71
	cvtsi2ss xmm1,eax
	imul	eax,esi,60
	add	eax,79
	cvtsi2ss xmm0,eax
	invoke	glVertex2f;(20+(loop1*60)+59,(70+loop2*40+1)); Top Right
	movss	xmm1,const1
	cvtsi2ss xmm0,edi
	mulss	xmm0,const0_1
	subss	xmm1,xmm0

	cvtsi2ss xmm0,esi
	mulss	xmm0,const0_1
	invoke	glTexCoord2f;loop1/10, 1-(loop2/10);

	imul	eax,edi,40
	add	eax,71
	cvtsi2ss xmm1,eax
	imul	eax,esi,60
	add	eax,21
	cvtsi2ss xmm0,eax
	invoke	glVertex2f;20+(loop1*60)+1, 70+loop2*40+1 	Top Left

	movss	xmm1,const0_9;_1
	cvtsi2ss xmm0,edi
	mulss	xmm0,const0_1
	subss	xmm1,xmm0

	cvtsi2ss xmm0,esi
	mulss	xmm0,const0_1
	invoke	glTexCoord2f;loop1/10, 1-(loop2/10)+0.1
	imul	eax,edi,40
	add	eax,109
	cvtsi2ss xmm1,eax
	imul	eax,esi,60
	add	eax,21
	cvtsi2ss xmm0,eax
	invoke	glVertex2f;(20+(loop1*60)+1,(70+loop2*40)+39); Bottom Left

	movss	xmm1,const0_9;_1
	cvtsi2ss xmm0,edi
	mulss	xmm0,const0_1
	subss	xmm1,xmm0

	cvtsi2ss xmm0,esi
	mulss	xmm0,const0_1
	addss	xmm0,const0_1
	invoke	glTexCoord2f;(loop1/10)+0.1, 1-(loop2/10)+0.1
	imul	eax,edi,40
	add	eax,109
	cvtsi2ss xmm1,eax
	imul	eax,esi,60
	add	eax,79
	cvtsi2ss xmm0,eax
	invoke	glVertex2f;(20+(loop1*60)+59,(70+loop2*40)+39); Bottom Right

	invoke	glEnd; Done Texturing the Box

@@:	invoke	glDisable,GL_TEXTURE_2D; Disable Texture Mapping
	dec	edi
	jns	@3
	dec	esi
	jns	@2

	movss	xmm0,const1
	invoke	glLineWidth; set the Line Width to 1.0

	cmp	anti,0;			 is anti TRUE?
	jz	@f
	invoke	glEnable,GL_LINE_SMOOTH; if so, enable antialiasing
@@:	
	invoke	rand
	movzx	edi,al
	invoke	rand
	movzx	esi,al
	invoke	rand
	movzx	r8d,al
	invoke	glColor3ub,esi,edi;rand%255,rand%255,rand%255		set Hourglass Color to Random Color

	invoke	glLoadIdentity;	 Reset the Modelview Matrix
	xorps	xmm2,xmm2
	mov	eax,player.fy
	add	eax,70
	cvtsi2ss xmm1,eax
	mov	eax,player.fx
	add	eax,20
	cvtsi2ss xmm0,eax
	invoke	glTranslatef;player.fx+20,player.fy+70,0 move to the fine Player position
	movss	xmm3,const1
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,player.spin
	invoke	glRotatef;player.spin,0,0,1		 Rotate Clockwise
	xorps	xmm2,xmm2
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glColor3f;0,1,0 set Player Color to Light Green

	invoke	glBegin,GL_LINES; Start Drawing Our Player Using lines
	xorps	xmm1,xmm1
	subss	xmm1,const5
	movss	xmm0,xmm1
	invoke	glVertex2f;-5,-5 Top Left of Player
	movss	xmm1,const5
	movss	xmm0,xmm1
	invoke	glVertex2f;5,5 Bottom Right of Player
	movss	xmm0,const5
	xorps	xmm1,xmm1
	subss	xmm1,xmm0
	invoke	glVertex2f;5,-5 Top Right of Player
	movss	xmm1,const5
	xorps	xmm0,xmm0
	subss	xmm0,xmm1
	invoke	glVertex2f;-5,5 Bottom Left of Player
	invoke	glEnd; Done Drawing the Player

	movss	xmm3,const1
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,const0_5
	mulss	xmm0,player.spin
	invoke	glRotatef;player.spin*0.5,0,0,1	 Rotate Clockwise
	xorps	xmm2,xmm2
	movss	xmm1,const0_75
	xorps	xmm0,xmm0
	invoke	glColor3f;0,0.75,0 set Player Color to Dark Green

	invoke	glBegin,GL_LINES; Start Drawing Our Player Using lines
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	subss	xmm0,const7
	invoke	glVertex2f;-7,0 Left Center of Player
	xorps	xmm1,xmm1
	movss	xmm0,const7
	invoke	glVertex2f;7,0 Right Center of Player
	xorps	xmm1,xmm1
	subss	xmm1,const7
	xorps	xmm0,xmm0
	invoke	glVertex2f;0,-7 Top Center of Player
	movss	xmm1,const7
	xorps	xmm0,xmm0
	invoke	glVertex2f;0,7 Bottom Center of Player
	invoke	glEnd; Done Drawing the Player

	mov	eax,level; Loop to draw enemies
	lea	eax,[rax*2+rax-3]
	mov	ecx,stage
	lea	eax,[rax+rcx-1]
	imul	edi,eax,sizeof object
@@:	invoke	glLoadIdentity; Reset the Modelview Matrix
;-----------------------------------------------------------
	xorps	xmm2,xmm2
	mov	eax,enemy[rdi].fy
	add	eax,70
	cvtsi2ss xmm1,eax
	mov	eax,enemy[rdi].fx
	add	eax,20
	cvtsi2ss xmm0,eax
	invoke	glTranslatef;
	movss	xmm2,const0_5
	movss	xmm1,xmm2
	movss	xmm0,const1
	invoke	glColor3f; Make Enemy Body Pink
	invoke	glBegin,GL_LINES; Start Drawing Enemy
	xorps	xmm1,xmm1
	subss	xmm1,const7
	xorps	xmm0,xmm0
	invoke	glVertex2f; Top Point of Body
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	subss	xmm0,const7
	invoke	glVertex2f;-7, 0; Left Point of Body
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	subss	xmm0,const7
	invoke	glVertex2f;-7, 0 Left Point of Body
	movss	xmm1,const7
	xorps	xmm0,xmm0
	invoke	glVertex2f;( 0, 7); Bottom Point of Body
	movss	xmm1,const7
	xorps	xmm0,xmm0
	invoke	glVertex2f;( 0, 7); Bottom Point of Body
	xorps	xmm1,xmm1
	movss	xmm0,const7
	invoke	glVertex2f;( 7, 0); Right Point of Body
	xorps	xmm1,xmm1
	movss	xmm0,const7
	invoke	glVertex2f;( 7, 0); Right Point of Body
	xorps	xmm1,xmm1
	subss	xmm1,const7
	xorps	xmm0,xmm0
	invoke	glVertex2f;( 0,-7); Top Point of Body
	invoke	glEnd; Done Drawing Enemy Body
	movss	xmm3,const1
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,enemy[rdi].spin
	invoke	glRotatef;(,,,1.0); Rotate the Enemy Blade
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glColor3f;(1.0f,0.0f,0.0f); Make Enemy Blade Red

	invoke	glBegin,GL_LINES; Start Drawing Enemy Blade
	xorps	xmm1,xmm1
	subss	xmm1,const7
	movss	xmm0,xmm1
	invoke	glVertex2f;(-7,-7); Top Left of Enemy
	movss	xmm1,const7
	movss	xmm0,xmm1
	invoke	glVertex2f;( 7, 7); Bottom Right of Enemy
	movss	xmm1,const7
	xorps	xmm0,xmm0
	subss	xmm0,xmm1
	invoke	glVertex2f;(-7, 7); Bottom Left of Enemy
	movss	xmm0,const7
	xorps	xmm1,xmm1
	subss	xmm1,xmm0
	invoke	glVertex2f;( 7,-7); Top Right of Enemy
	invoke	glEnd; Done Drawing Enemy Blade
	sub	edi,sizeof object
	jns	@b
;----------------------------------------------------------
	test	Status,00000011y;is Complete=TRUE or gameover=TRUE ?
	jnz	@14
	mov	eax,level; Loop to draw enemies
	lea	eax,[rax*2+rax-3]
	mov	ecx,stage
	lea	eax,[rax+rcx-1]
	imul	edi,eax,sizeof object
@15:   	mov	eax,enemy[rdi].fy
	cmp	player.fy,eax
	jz	@f
	sbb	eax,eax
	or	al,1
	add	enemy[rdi].fy,eax
@@:     mov	eax,enemy[rdi].fx
	cmp	player.fx,eax
	jz	@f
	sbb	eax,eax
	or	al,1
	add	enemy[rdi].fx,eax
	jmp	@14
@@:     mov	eax,enemy[rdi].fy
	cmp	player.fy,eax
	jnz	@14
	dec	lives
	jnz	@f
	or	Status,1;set gameover=TRUE

@@:	invoke	glLoadIdentity; Reset the Modelview Matrix
	invoke	ResetObjects
	mov	ecx,offset szSnd1;"Die.wav"
	invoke	PlaySound,,NULL,SND_SYNC;	// Play The Death Sound
@14:	sub	edi,sizeof object
	jns	@15

;----------------------------------------------------------------
	xor	eax,eax
	mov	edi,offset vline
	mov	ecx,220
	repne	scasb
	or	ecx,ecx
	jne	@f
	or	Status,00000110y;set Complete=TRUE set SndComplete=TRUE	
@@:	
;---------------------------------------------------------------
;   
        invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke  EndPaint,hWin
wmBYE:	xor	eax,eax
	leave
	retn	
WndProc	endp

ResetObjects proc
local	old_edi:dword
local	temp:dword

	mov	old_edi,edi

	and	player.x,0;=0; Reset Player X position to Far Left of the screen
	and	player.y,0;=0; Reset Player Y position to the Top of the screen
	and	player.fx,0;=0; set fine X position to match
	and	player.fy,0;=0; set fine Y position to match

	mov	edi,(sizeof object)*8;				// Loop Through all the enemies
@@:	invoke	rand
	xor	edx,edx
	mov	ecx,360
	div	ecx
	add	edx,5
	mov	enemy[rdi].fx,edx;=5+rand%6	 Select a Random X position
	invoke	rand
	xor	edx,edx
	mov	ecx,440
	div	ecx
	mov	enemy[rdi].fy,edx;=rand%11;	 Select a Random Y position
	sub	edi,sizeof object
	jns	@b

	mov	edi,old_edi
	leave
	ret
ResetObjects endp

BuildFont proc
local	cx_:dword
local	cy:dword
local	old_edi:dword

        mov	old_edi,edi

	invoke	glGenLists,256;	 Creating 256 Display Lists
	mov	base,eax
	mov	edx,Texture1_Id[0*4]
	invoke	glBindTexture,GL_TEXTURE_2D; Select Our Font Texture

	xor	edi,edi;loop1=0; loop1<256; loop1++)	 Loop Through all 256 Lists
@@:	mov	eax,edi
	and	eax,15;esi%16
	mov	edx,edi
	shr	edx,4;esi/16
	cvtsi2ss xmm0,eax
	mulss	xmm0,const0_0625;divss	xmm0,const16
	movss	cx_,xmm0;cx=(loop1%16)/16.0 X position of current character

	cvtsi2ss xmm0,edx
	mulss	xmm0,const0_0625;divss	xmm0,const16
	movss	cy,xmm0;cy=(loop1%16)/16.0 Y position of current character

	mov	ecx,base
	add	ecx,edi
	invoke	glNewList,,GL_COMPILE; Start Building a List

	invoke	glBegin,GL_QUADS; Use a Quad for Each character
	movss	xmm1,const1
	subss	xmm1,cy
	subss	xmm1,const0_0625
	movss	xmm0,cx_
	invoke	glTexCoord2f;cx,1-cy-0.0625 Texture Coord (Bottom Left)
	invoke	glVertex2i,0,16; Vertex Coord (Bottom Left)
	movss	xmm1,const0_9375;=1-0.0625
	subss	xmm1,cy
	movss	xmm0,cx_
	addss	xmm0,const0_0625
	invoke	glTexCoord2f;cx+0.0625,1-cy-0.0625 Texture Coord (Bottom Right)
	invoke	glVertex2i,16,16; Vertex Coord (Bottom Right)
	movss	xmm1,const1
	subss	xmm1,cy
	movss	xmm0,cx_
	addss	xmm0,const0_0625
	invoke	glTexCoord2f;cx+0.0625,1-cy Texture Coord (Top Right)
	invoke	glVertex2i,16,0; Vertex Coord (Top Right)
	movss	xmm1,const1
	subss	xmm1,cy
	movss	xmm0,cx_
	invoke	glTexCoord2f;cx,1-cy Texture Coord (Top Left)
	invoke	glVertex2i,0,0; Vertex Coord (Top Left)
	invoke	glEnd; Done Building Our Quad (character)
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,const15
	invoke	glTranslatef;15,0,0 move to the Right of the character
	invoke	glEndList; Done Building the Display List
	inc	edi; Loop Until all 256 are Built
	cmp	edi,256
	jb	@b

        mov	edi,old_edi
	leave
	ret
BuildFont endp
glPrint proc x:dword, y:dword, set:dword, fmt:dword,params:VARARG; Where the Printing Happens
local	text[256]:byte;   
local	len:dword
	movss	x,xmm0
	movss	y,xmm1
	mov	set,r8d
	mov	fmt,r9d

	or	r9d,r9d;if (fmt == NULL);   
	jz	@9; 
	lea	r8d,params
	mov	edx,r9d;fmt
	lea	ecx,text
	invoke	vsprintf;(, fmt, ap); And Converts Symbols to Actual Numbers
	mov	len,eax
; Parses the String for Variables
; Results are stored in Text
	cmp	set,1;     ?
	jna	@f	
	mov	set,1; ,    1 ()
@@:	invoke	glEnable,GL_TEXTURE_2D;  
	invoke	glLoadIdentity;   
	xorps	xmm2,xmm2
	movss	xmm1,y
	movss	xmm0,x
	invoke	glTranslatef;,x,y,0;  (0,0   )
	mov	eax,set
	shl	eax,7
	mov	ecx,base
	sub	ecx,32
	add	ecx,eax
	invoke	glListBase;(base-32+(128*set)); Choose the Font set (0 or 1)
	cmp	set,0;   (0  1)
	jnz	@f   ; 0   
	movss	xmm2,const1
	movss	xmm1,const2
	movss	xmm0,const1_5
	invoke	glScalef;1.5,2,1;     
@@:	mov	ecx,len
	lea	r8d, text
	invoke	glCallLists,,GL_UNSIGNED_BYTE;   
	invoke	glDisable,GL_TEXTURE_2D;  
@9:	leave
	ret
glPrint endp
;---------------------------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson#20: Line Tutorial",0
FileName	db "br_Rabbit3.cur",0
szTex0		db "Font.bmp",0; Load the Font
szTex1		db "Image00.bmp",0
szTex2		db "Image01.bmp",0
szTex3		db "Image02.bmp",0
szTex4		db "Image03.bmp",0
szTex5		db "Image04.bmp",0
szTex6		db "Image05.bmp",0
szTex7		db "Image06.bmp",0
szTex8		db "Image07.bmp",0
szTex9		db "Image08.bmp",0
FileName0	dd offset szTex0,offset szTex1,offset szTex2,offset szTex3,offset szTex4
		dd offset szTex5,offset szTex6,offset szTex7,offset szTex8,offset szTex9
Grid_Crazy	db "GRID CRAZY",0
aLives		db "Lives:%2i",0
aLevel		db "Level:%2i",0
aStage		db "Stage:%2i",0
aGame		db "GAME OVER",0; Write GAME OVER to the screen
aPress		db "PRESS SPACE",0
aYou_are_win	db "You are win!",0
szSnd1		db "Die.wav",0
lives		dd 5
level		dd 1
stage		dd 1
anti		db TRUE
Texture1_Id	dd 10 dup (?)
base		dd ?
player		object <>
enemy		object 9 dup(<>)
filled		db ?
Status		db FALSE ;2-SndCompleate 1-Compleate 0-gameover
vline		db 11*10 dup (0)
hline		db 10*11 dup (0)
;-----------------------------
;float
const0_0625 	dd 0.0625
const0_1 	dd 0.1
const0_5 	dd 0.5
const0_75 	dd 0.75
const0_9	dd 0.9
const0_9375	dd 0.9375
const1		dd 1.0
const1_5	dd 1.5
const2		dd 2.0
const5		dd 5.0
const7		dd 7.0
const15		dd 15.0
const20		dd 20.0
const24		dd 24.0
const38		dd 38.0
const40		dd 40.0
const207	dd 207.0
const360	dd 360.0
const448	dd 448.0
const456	dd 456.0
const472	dd 472.0
const490	dd 490.0
;double
constd1		dq 1.0
constd_1	dq -1.0
end